#include <iostream>
#include "bix.hpp"

int my_add(lua_State *l) {
    float x = (float)luaL_checknumber(l, 1); // reads a value from the stack,
                                     // verifying it is a number
    float y = (float)luaL_checknumber(l, 2);
    const float result = x + y;
    lua_pushnumber(l, result);
    return 1; // return the arity of this function
}

void lua_test()
{
	// open a lua context
	lua_State *l = luaL_newstate();

	// bind the function pointer to global "c_my_add"
	lua_register(l, "c_my_add", &my_add);
}


int main()
{
	std::cout<<"Bix\n";

	Bix::State state;
	luaL_openlibs(state._l);
	luaL_dostring(state._l, "print('xxx');");
	
	// Push function name to the stack
	lua_getglobal(state._l, "print");
	auto num_args = state.Push(50, "xass", 50.66, "dogonast", 23423432);
	lua_call(state._l, num_args, 0);
	std::cout << "\nnum_args = " << num_args;

	return 0;
}